## vuos 0.9.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project("vuos"
		VERSION 0.1.0
		DESCRIPTION ""
		HOMEPAGE_URL "https://github.com/virtualsquare/vuos"
		LANGUAGES C)

include(GNUInstallDirs)
include(CheckIncludeFile)
include(CheckSymbolExists)

set(LIBS_REQUIRED stropt volatilestream execs vdeplug fuse3)
set(HEADERS_REQUIRED stropt.h strcase.h volatilestream.h execs.h libvdeplug.h fuse3/fuse.h pthread.h)
# DFUSE_USE_VERSION 300 is just to test fuse3-dev availability
set(CMAKE_REQUIRED_DEFINITIONS -D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=300)

foreach(THISLIB IN LISTS LIBS_REQUIRED)
  find_library(LIB${THISLIB}_OK ${THISLIB})
  if(NOT LIB${THISLIB}_OK)
    message(FATAL_ERROR "library lib${THISLIB} not found")
  endif()
endforeach(THISLIB)

foreach(HEADER IN LISTS HEADERS_REQUIRED)
  check_include_file(${HEADER} ${HEADER}_OK)
  if(NOT ${HEADER}_OK)
    message(FATAL_ERROR "header file ${HEADER} not found")
  endif()
endforeach(HEADER)
unset(CMAKE_REQUIRED_DEFINITIONS)

set(CMAKE_C_FLAGS
		"-ggdb -Wall -Wextra -pedantic -std=gnu11 -Wno-unused-parameter -O2 -D_FORTIFY_SOURCE=2")
add_definitions(-D_GNU_SOURCE)

set(MODULES_INSTALL_PATH ${CMAKE_INSTALL_FULL_LIBDIR}/vu/modules)
set(CONFIGURATION_DIR_PATH ${CMAKE_INSTALL_FULL_SYSCONFDIR})
set(HEADERS_INSTALL_PATH ${CMAKE_INSTALL_FULL_INCLUDEDIR})
set(VU_HEADERS ${PROJECT_SOURCE_DIR}/include)
set(VU_DYN_SOURCE_PATH ${CMAKE_BINARY_DIR}/umvu_dynsrc)
set(VU_DYN_HEADER_PATH ${CMAKE_BINARY_DIR}/include)

set(VU_SYSCALL_DEFS ${VU_DYN_HEADER_PATH}/syscall_defs.h)
set(R_TABLE_H ${VU_DYN_HEADER_PATH}/r_table.h)
set(SYSCALL_NR_COMPAT_H ${VU_DYN_HEADER_PATH}/syscall_nr_compat.h)
set(VU_SYSNAMES ${VU_DYN_SOURCE_PATH}/syscall_names.c)
set(VU_ARCHTABLE ${VU_DYN_SOURCE_PATH}/arch_table.c)
set(VU_SYSTABLE ${VU_DYN_SOURCE_PATH}/syscall_table.c)
set(VU_DYN_SOURCES ${VU_SYSNAMES} ${VU_ARCHTABLE} ${VU_SYSTABLE})

execute_process(COMMAND mkdir -p ${VU_DYN_SOURCE_PATH})

foreach(DYN ${VU_DYN_SOURCES})
	execute_process(COMMAND touch -d 20000101 ${DYN})
endforeach(DYN)

configure_file( ${VU_HEADERS}/config.h.in ${VU_DYN_HEADER_PATH}/config.h )

add_subdirectory(scripts)
add_subdirectory(umvu)
add_subdirectory(cmd)
add_subdirectory(test_modules)
add_subdirectory(libvumod)
add_subdirectory(vufuse)
add_subdirectory(vudev)
add_subdirectory(vudevfuse)
add_subdirectory(include)
add_subdirectory(vunet)
add_subdirectory(vufs)
add_subdirectory(vubinfmt)
add_subdirectory(vumisc)
add_subdirectory(vunet_modules)
add_subdirectory(vufuse_modules)
add_subdirectory(vudev_modules)
add_subdirectory(vumisc_modules)
add_subdirectory(man)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${PROJECT_SOURCE_DIR}/Uninstall.cmake")

=== include/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

file(GLOB VU_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/*.h)
install(FILES ${VU_HEADERS} DESTINATION ${HEADERS_INSTALL_PATH})

=== libvumod/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
set(VUMODLIB_VERSION_STRING 0.0.1)
set(VUMODLIB_VERSION_MAJOR 0)

include_directories(${VU_HEADERS})
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)

file(GLOB VUMODLIB_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.c)
add_library(vumod SHARED ${VUMODLIB_SOURCES})
target_link_libraries(vumod volatilestream)

set_target_properties(vumod PROPERTIES VERSION ${VUMODLIB_VERSION_STRING}
        SOVERSION ${VUMODLIB_VERSION_MAJOR})

install(TARGETS vumod LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== man/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

set(PANDOC_ORG "VirtualSquare-VUOS")

# ### pandoc pages

file(GLOB VU_PANDOC_PAGES ${CMAKE_CURRENT_SOURCE_DIR}/*.[1-8].md)
set(VU_MAN_FILES)
foreach(VU_PANDOC_PATH IN LISTS VU_PANDOC_PAGES)
# VU_PANDOCPAGE: basename of VU_PANDOC_PATH
	get_filename_component(VU_PANDOCPAGE ${VU_PANDOC_PATH} NAME)
# VU_MANPAGE: VU_PANDOCPAGE without the suffix
	string(REGEX REPLACE "\.md$" "" VU_MANPAGE ${VU_PANDOCPAGE})
	list(APPEND VU_MAN_FILES ${VU_MANPAGE})
endforeach(VU_PANDOC_PATH)

add_custom_target(${PROJECT_NAME}_manpages ALL make PANDOC_ORG="${PANDOC_ORG}"  ${VU_MAN_FILES}
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

### man pages
file(GLOB VU_MAN_PAGES ${CMAKE_CURRENT_SOURCE_DIR}/*.[1-8])
foreach(VU_MAN_PATH IN LISTS VU_MAN_PAGES)
	get_filename_component(VU_MANPAGE ${VU_MAN_PATH} NAME)
	string(REGEX REPLACE ".*\\." "" MAN_CHAPTER ${VU_MANPAGE})
	install(FILES ${VU_MAN_PATH} DESTINATION ${CMAKE_INSTALL_MANDIR}/man${MAN_CHAPTER})
endforeach(VU_MAN_PATH)

=== test_modules/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

include_directories(${VU_HEADERS})
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)

file(GLOB VU_MODULES ${CMAKE_CURRENT_SOURCE_DIR}/*.c)

foreach(VU_MOD ${VU_MODULES})
    string(REPLACE ".c" "" VU_MOD_FILE ${VU_MOD})
    get_filename_component(VU_MOD_TARGET ${VU_MOD_FILE} NAME)
    add_library(${VU_MOD_TARGET} SHARED ${VU_MOD})
    set_target_properties(${VU_MOD_TARGET} PROPERTIES PREFIX "")
    install(TARGETS ${VU_MOD_TARGET} LIBRARY DESTINATION ${MODULES_INSTALL_PATH})
endforeach(VU_MOD)

target_link_libraries(unrealinfofs vumod)

=== umvu/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

set(UMVU_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src)
set(UMVU_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/include)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)

file(GLOB_RECURSE UMVU_SOURCES ${UMVU_SOURCES}/*.c)
list(APPEND UMVU_SOURCES ${VU_DYN_SOURCES})

include_directories(${UMVU_HEADERS} ${VU_DYN_HEADER_PATH} ${VU_HEADERS})
add_executable(umvu ${UMVU_SOURCES})
set_property(TARGET umvu PROPERTY ENABLE_EXPORTS 1)
target_link_libraries(umvu pthread dl)

install(TARGETS umvu
  RUNTIME DESTINATION bin)

=== vudev/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

include_directories(${VU_HEADERS})

set(VU_MOD_TARGET vudev)
file(GLOB_RECURSE VUDEV_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.c)

add_library(${VU_MOD_TARGET} SHARED ${VUDEV_SOURCES})
set_target_properties(${VU_MOD_TARGET} PROPERTIES PREFIX "")
target_link_libraries(${VU_MOD_TARGET} stropt)

install(TARGETS ${VU_MOD_TARGET} LIBRARY DESTINATION ${MODULES_INSTALL_PATH})

=== vudev_modules/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

include_directories(${VU_HEADERS} ${VU_DYN_HEADER_PATH})
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)

file(GLOB VUDEV_MODULES ${CMAKE_CURRENT_SOURCE_DIR}/*.c)

foreach(VUDEV_MOD ${VUDEV_MODULES})
    string(REGEX REPLACE "\.c$" "" VUDEV_MOD_FILE ${VUDEV_MOD})
    get_filename_component(VUDEV_MOD_TARGET ${VUDEV_MOD_FILE} NAME)
    add_library(${VUDEV_MOD_TARGET} SHARED ${VUDEV_MOD})
    set_target_properties(${VUDEV_MOD_TARGET} PROPERTIES PREFIX "")
    install(TARGETS ${VUDEV_MOD_TARGET} LIBRARY DESTINATION ${MODULES_INSTALL_PATH})
endforeach(VUDEV_MOD)

=== vumisc/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

include_directories(${VU_HEADERS})

set(VU_MOD_TARGET vumisc)
file(GLOB_RECURSE VUMISC_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.c)

add_library(${VU_MOD_TARGET} SHARED ${VUMISC_SOURCES})
set_target_properties(${VU_MOD_TARGET} PROPERTIES PREFIX "")

target_link_libraries(${VU_MOD_TARGET} vumod)

install(TARGETS ${VU_MOD_TARGET} LIBRARY DESTINATION ${MODULES_INSTALL_PATH})

=== vunet/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

include_directories(${VU_HEADERS})

set(VU_MOD_TARGET vunet)
file(GLOB_RECURSE VUNET_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.c)

add_library(${VU_MOD_TARGET} SHARED ${VUNET_SOURCES})
set_target_properties(${VU_MOD_TARGET} PROPERTIES PREFIX "")

install(TARGETS ${VU_MOD_TARGET} LIBRARY DESTINATION ${MODULES_INSTALL_PATH})

=== vunet_modules/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

include_directories(${VU_HEADERS} ${VU_DYN_HEADER_PATH})
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)

file(GLOB VUNET_MODULES ${CMAKE_CURRENT_SOURCE_DIR}/*.c)

foreach(VUNET_MOD ${VUNET_MODULES})
    string(REGEX REPLACE "\.c$" "" VUNET_MOD_FILE ${VUNET_MOD})
    get_filename_component(VUNET_MOD_TARGET ${VUNET_MOD_FILE} NAME)
    add_library(${VUNET_MOD_TARGET} SHARED ${VUNET_MOD})
    set_target_properties(${VUNET_MOD_TARGET} PROPERTIES PREFIX "")
    install(TARGETS ${VUNET_MOD_TARGET} LIBRARY DESTINATION ${MODULES_INSTALL_PATH})
endforeach(VUNET_MOD)

target_link_libraries(vunetvdestack vdeplug)

=== debian/changelog ===
vuos (0.9.1-1) unstable; urgency=medium

  * Team upload.

  [ Renzo Davoli ]
  * New upstream version 0.9.1.

  [ Mattia Rizzolo ]
  * Change maintainer to the virtualsquare team.
  * Add Conflicts:umview to vuos-cmds. Closes: #1095963
  * Add lintian override for shared-library-lacks-prerequisites.

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 17 Feb 2025 11:13:33 +0100

vuos (0.9.0-1) unstable; urgency=medium

  * Initial release

 -- Renzo Davoli <renzo@cs.unibo.it>  Sat, 25 Jan 2025 16:51:49 +0100

=== debian/control ===
Source: vuos
Priority: optional
Section: utils
Maintainer: Debian VirtualSquare Team <virtualsquare@cs.unibo.it>
Uploaders:
 Renzo Davoli <renzo@cs.unibo.it>,
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 3.12),
 libcap-dev,
 libexecs-dev,
 libfuse3-dev,
 libstropt-dev,
 libvdeplug-dev,
 libvolatilestream-dev,
 python3-minimal,
 strcase-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: http://www.virtualsquare.org/
Vcs-Git: https://salsa.debian.org/virtualsquare-team/vuos.git
Vcs-Browser: https://salsa.debian.org/virtualsquare-team/vuos

Package: vuos
Section: metapackages
Architecture: amd64
Depends:
 vuos-cmds,
 vuos-modules,
 vuos-umvu,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Virtual Operating System at user space metapackage
 Virtual Operating System at user space. Currently it implements about 150
 Linux-compatible system calls providing support for a wide range of
 applications. Each process or even each thread in VUOS can see a different
 execution environment: file system contents, networking, devices, user ids,
 etc. The main idea behind VUOS is that it is possible to give processes
 their own "view" using partial virtual machines
 .
 This metapackage installs vuos hypervisors and modules

Package: vuos-modules
Architecture: amd64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Virtual Operating System at user space: modules
 Virtual Operating System at user space. Currently it implements about 150
 Linux-compatible system calls providing support for a wide range of
 applications. Each process or even each thread in VUOS can see a different
 execution environment: file system contents, networking, devices, user ids,
 etc. The main idea behind VUOS is that it is possible to give processes
 their own "view" using partial virtual machines
 .
 This package contains the vuos modules

Package: vuos-cmds
Architecture: amd64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 umview,
Description: Virtual Operating System at user space: commands
 Virtual Operating System at user space. Currently it implements about 150
 Linux-compatible system calls providing support for a wide range of
 applications. Each process or even each thread in VUOS can see a different
 execution environment: file system contents, networking, devices, user ids,
 etc. The main idea behind VUOS is that it is possible to give processes
 their own "view" using partial virtual machines
 .
 This package contains the vuos commands

Package: vuos-umvu
Architecture: amd64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Virtual Operating System at user space: umvu hypervisor
 Virtual Operating System at user space. Currently it implements about 150
 Linux-compatible system calls providing support for a wide range of
 applications. Each process or even each thread in VUOS can see a different
 execution environment: file system contents, networking, devices, user ids,
 etc. The main idea behind VUOS is that it is possible to give processes
 their own "view" using partial virtual machines
 .
 This package contains the umvu hypervisor

Package: libvumod0
Architecture: amd64
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Virtual Operating System at user space: library
 Virtual Operating System at user space. Currently it implements about 150
 Linux-compatible system calls providing support for a wide range of
 applications. Each process or even each thread in VUOS can see a different
 execution environment: file system contents, networking, devices, user ids,
 etc. The main idea behind VUOS is that it is possible to give processes
 their own "view" using partial virtual machines
 .
 This package contains the vuos library

Package: libvumod-dev
Architecture: amd64
Section: libdevel
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Virtual Operating System at user space: library dev resources
 Virtual Operating System at user space. Currently it implements about 150
 Linux-compatible system calls providing support for a wide range of
 applications. Each process or even each thread in VUOS can see a different
 execution environment: file system contents, networking, devices, user ids,
 etc. The main idea behind VUOS is that it is possible to give processes
 their own "view" using partial virtual machines
 .
 This package contains the vuos library (resources for devs)

## vuos 0.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.13)
 project("vuos"
-		VERSION 0.1.0
+		VERSION 0.9.2
 		DESCRIPTION ""
 		HOMEPAGE_URL "https://github.com/virtualsquare/vuos"
 		LANGUAGES C)

=== cmd/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

include_directories(${VU_HEADERS})
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)

file(GLOB VU_CMDS ${CMAKE_CURRENT_SOURCE_DIR}/*.c)

foreach(VU_CMD ${VU_CMDS})
    string(REPLACE ".c" "" VU_CMD_FILE ${VU_CMD})
		get_filename_component(VU_CMD_TARGET ${VU_CMD_FILE} NAME)
    add_executable(${VU_CMD_TARGET} ${VU_CMD})
    install(TARGETS ${VU_CMD_TARGET} RUNTIME DESTINATION bin)
endforeach(VU_CMD)

target_link_libraries(vumount stropt)
target_link_libraries(vustack stropt)

=== scripts/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

set(VU_SYSCALL_CONF ${PROJECT_SOURCE_DIR}/vu_syscalls.conf)
set(VU_SCRIPT_PATH ${PROJECT_SOURCE_DIR}/scripts)

add_custom_target(Dynamic_Sources ALL
		DEPENDS ${VU_SYSCALL_DEFS} ${VU_ARCHTABLE} ${SYSCALL_NR_COMPAT_H} ${VU_SYSNAMES} ${VU_SYSTABLE} ${R_TABLE_H})
add_custom_command(OUTPUT ${VU_DYN_HEADER_PATH}
		COMMAND mkdir ${VU_DYN_HEADER_PATH})
add_custom_command(OUTPUT ${VU_DYN_SOURCE_PATH}
		COMMAND mkdir ${VU_DYN_SOURCE_PATH})

execute_process(COMMAND ${VU_SCRIPT_PATH}/syscall_deps.sh ${CMAKE_C_COMPILER}
		OUTPUT_VARIABLE SYSCALL_DEPS)

# syscall_defs.h
add_custom_command(OUTPUT ${VU_SYSCALL_DEFS}
		COMMAND ${VU_SCRIPT_PATH}/syscall_defs_gen.py ${VU_SYSCALL_CONF} > ${VU_SYSCALL_DEFS}
		COMMENT "Populating VU syscall list"
		DEPENDS ${VU_SYSCALL_CONF} ${VU_DYN_HEADER_PATH})

# r_table.h
add_custom_command(OUTPUT ${R_TABLE_H}
		COMMAND ${VU_SCRIPT_PATH}/r_table_gen.sh ${CMAKE_C_COMPILER} ${VU_SCRIPT_PATH} > ${R_TABLE_H}
		COMMENT "Generating r_table"
		DEPENDS ${VU_DYN_HEADER_PATH} ${SYSCALL_DEPS})

# syscall_nr_compat_gen.h
add_custom_command(OUTPUT ${SYSCALL_NR_COMPAT_H}
		COMMAND ${VU_SCRIPT_PATH}/syscall_nr_compat_gen.py ${VU_SYSCALL_CONF} > ${SYSCALL_NR_COMPAT_H}
		COMMENT "Generating syscall NR compat list"
		DEPENDS ${VU_SYSCALL_CONF} ${VU_DYN_HEADER_PATH})

# syscall_names.c
add_custom_command(OUTPUT ${VU_SYSNAMES}
		COMMAND ${VU_SCRIPT_PATH}/syscall_names_gen.sh ${CMAKE_C_COMPILER} ${VU_SCRIPT_PATH} > ${VU_SYSNAMES}
		COMMENT "Generating syscall names table"
		DEPENDS ${VU_DYN_SOURCE_PATH} ${SYSCALL_DEPS})

# arch_table.c
add_custom_command(OUTPUT ${VU_ARCHTABLE}
		COMMAND ${VU_SCRIPT_PATH}/archtable_gen.py ${ARCH} ${VU_SYSCALL_CONF} > ${VU_ARCHTABLE}
		COMMENT "Generating architecture table"
		DEPENDS ${VU_SYSCALL_CONF} ${VU_DYN_SOURCE_PATH})

# syscall_table.c
add_custom_command(OUTPUT ${VU_SYSTABLE}
		COMMAND ${VU_SCRIPT_PATH}/syscall_table_gen.py ${VU_SYSCALL_CONF} > ${VU_SYSTABLE}
		COMMENT "Generating VU syscall table"
		DEPENDS ${VU_SYSCALL_CONF} ${VU_DYN_SOURCE_PATH})

=== vubinfmt/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

include_directories(${VU_HEADERS})

set(VU_MOD_TARGET vubinfmt)
file(GLOB_RECURSE VUBINFMT_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.c)

add_library(${VU_MOD_TARGET} SHARED ${VUBINFMT_SOURCES})
set_target_properties(${VU_MOD_TARGET} PROPERTIES PREFIX "")
target_link_libraries(${VU_MOD_TARGET} stropt vumod)

install(TARGETS ${VU_MOD_TARGET} LIBRARY DESTINATION ${MODULES_INSTALL_PATH})

=== vudevfuse/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

include_directories(${VU_HEADERS} ${CMAKE_CURRENT_SOURCE_DIR})

set(VU_MOD_TARGET fuse)
file(GLOB_RECURSE VUDEV_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.c)

add_library(${VU_MOD_TARGET} SHARED ${VUDEV_SOURCES})
set_target_properties(${VU_MOD_TARGET} PROPERTIES PREFIX "")
target_link_libraries(${VU_MOD_TARGET} stropt volatilestream)

install(TARGETS ${VU_MOD_TARGET} LIBRARY DESTINATION ${MODULES_INSTALL_PATH})

=== vufs/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

include_directories(${VU_HEADERS} ${CMAKE_CURRENT_SOURCE_DIR})

set(VU_MOD_TARGET vufs)
file(GLOB_RECURSE VUFS_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.c)

add_library(${VU_MOD_TARGET} SHARED ${VUFS_SOURCES})
set_target_properties(${VU_MOD_TARGET} PROPERTIES PREFIX "")
target_link_libraries(${VU_MOD_TARGET} stropt volatilestream)

install(TARGETS ${VU_MOD_TARGET} LIBRARY DESTINATION ${MODULES_INSTALL_PATH})

=== vufuse/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=314")

include_directories(${VU_HEADERS} ${CMAKE_CURRENT_SOURCE_DIR})

set(VU_MOD_TARGET vufuse)
file(GLOB_RECURSE VUFUSE_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.c)

add_library(${VU_MOD_TARGET} SHARED ${VUFUSE_SOURCES})
set_target_properties(${VU_MOD_TARGET} PROPERTIES PREFIX "")
target_link_libraries(${VU_MOD_TARGET} stropt volatilestream execs)

install(TARGETS ${VU_MOD_TARGET} LIBRARY DESTINATION ${MODULES_INSTALL_PATH})

=== vufuse_modules/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

include_directories(${VU_HEADERS} ${VU_DYN_HEADER_PATH})
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)

file(GLOB VUFUSE_MODULES ${CMAKE_CURRENT_SOURCE_DIR}/vu*.c)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_FILE_OFFSET_BITS=64")

foreach(VUFUSE_MOD ${VUFUSE_MODULES})
    string(REGEX REPLACE "\.c$" "" VUFUSE_MOD_FILE ${VUFUSE_MOD})
    get_filename_component(VUFUSE_MOD_TARGET ${VUFUSE_MOD_FILE} NAME)
    add_library(${VUFUSE_MOD_TARGET} SHARED ${VUFUSE_MOD})
    set_target_properties(${VUFUSE_MOD_TARGET} PROPERTIES PREFIX "")
		target_compile_definitions(${VUFUSE_MOD_TARGET} PUBLIC PROGNAME="${VUFUSE_MOD_TARGET}")
    install(TARGETS ${VUFUSE_MOD_TARGET} LIBRARY DESTINATION ${MODULES_INSTALL_PATH})
endforeach(VUFUSE_MOD)

foreach(VUFUSE_MOD ${VUFUSE_MODULES})
    string(REGEX REPLACE "\.c$" "" VUFUSE_MOD_FILE ${VUFUSE_MOD})
    get_filename_component(VUFUSE_MOD_EXE ${VUFUSE_MOD_FILE} NAME)
    string(REGEX REPLACE "^vu" "" VUFUSE_MOD_EXE ${VUFUSE_MOD_EXE})
		set(VUFUSE_MOD_TARGET ${VUFUSE_MOD_EXE})
    add_executable(${VUFUSE_MOD_TARGET} ${VUFUSE_MOD})
		set_target_properties(${VUFUSE_MOD_TARGET} PROPERTIES OUTPUT_NAME ${VUFUSE_MOD_EXE})
		target_compile_definitions(${VUFUSE_MOD_TARGET} PUBLIC PROGNAME="${VUFUSE_MOD_TARGET}")
    target_link_libraries(${VUFUSE_MOD_TARGET} -lfuse3)
    install(TARGETS ${VUFUSE_MOD_TARGET} RUNTIME DESTINATION bin)
endforeach(VUFUSE_MOD)

=== vumisc_modules/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

include_directories(${VU_HEADERS} ${VU_DYN_HEADER_PATH})
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)

file(GLOB VUMISC_MODULES ${CMAKE_CURRENT_SOURCE_DIR}/*.c)

foreach(VUMISC_MOD ${VUMISC_MODULES})
    string(REGEX REPLACE "\.c$" "" VUMISC_MOD_FILE ${VUMISC_MOD})
    get_filename_component(VUMISC_MOD_TARGET ${VUMISC_MOD_FILE} NAME)
    add_library(${VUMISC_MOD_TARGET} SHARED ${VUMISC_MOD})
    set_target_properties(${VUMISC_MOD_TARGET} PROPERTIES PREFIX "")
    install(TARGETS ${VUMISC_MOD_TARGET} LIBRARY DESTINATION ${MODULES_INSTALL_PATH})
endforeach(VUMISC_MOD)

# target_link_libraries(vumiscmod modlib)

=== debian/changelog ===
vuos (0.9.2-1) unstable; urgency=medium

  * Team upload.

  [ Renzo Davoli ]
  * New upstream version 0.9.2.
    + Fix build with fuse 3.17.  Closes: #1098735

  [ Mattia Rizzolo ]
  * Bump Standards-Version to 4.7.2, no changes needed

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 19 Mar 2025 10:29:53 +0100

## vuos 0.9.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
-cmake_minimum_required(VERSION 3.13)
+cmake_minimum_required(VERSION 3.25)
 project("vuos"
-		VERSION 0.9.2
+		VERSION 0.9.4
 		DESCRIPTION ""
 		HOMEPAGE_URL "https://github.com/virtualsquare/vuos"
 		LANGUAGES C)

=== cmd/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.13)
+cmake_minimum_required(VERSION 3.25)
 
 include_directories(${VU_HEADERS})
 set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)

=== include/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25)

file(GLOB VU_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/*.h)
install(FILES ${VU_HEADERS} DESTINATION ${HEADERS_INSTALL_PATH})

=== libvumod/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.13)
+cmake_minimum_required(VERSION 3.25)
 set(VUMODLIB_VERSION_STRING 0.0.1)
 set(VUMODLIB_VERSION_MAJOR 0)

=== man/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.13)
+cmake_minimum_required(VERSION 3.25)
 
 set(PANDOC_ORG "VirtualSquare-VUOS")

=== man/Makefile ===
MAKEFLAGS += --silent
PANDOC=pandoc
PANDOCOK := $(shell command -v ${PANDOC} 2> /dev/null)
PANDOCMINVER=3.1.7

ifdef PANDOCOK
PANDOCVER := $(shell ${PANDOC} -v | head -1 | cut -d ' ' -f 2)
PANDOCVEROK := $(shell printf '%s\n' ${PANDOCMINVER} ${PANDOCVER} | sort -C -V; echo $$?)
endif

none:

% : %.md
ifdef PANDOCOK
ifeq (${PANDOCVEROK}, 1)
		echo "${PANDOC} ${PANDOCVER} < ${PANDOCMINVER}. $@ can create font warnings with man/groff" >&2
endif
# copy copyright notice
		grep "^\.\\\\\"" $< > $@ || true
# run pandoc
		$(eval SECTION := $(subst .,,$(suffix $@)))
		$(eval BASENAME := $(basename $@))
		$(eval TITLE := $(shell echo "${BASENAME}\(${SECTION}\)" | tr [:lower:] [:upper:]))
		$(eval HEADER := "$(shell man ${SECTION} intro | head -1 | sed -e 's/^[^[:blank:]]*[[:blank:]]*//' -e 's/[[:blank:]]*[^[:blank:]]*$$//' )")
		$(PANDOC) -standalone -M title=${TITLE} -M section=${SECTION} -M header=${HEADER} -M footer=${PANDOC_ORG} -M "date=`date +\"%B %Y\"`" --to man $< >> $@
# workaround for boldface rendering
		sed -i -e 's/\\f\[CR\]/\\f\[CB\]/g' $@ || true
		echo "$@ manpage updated" >&2
else
		echo "${PANDOC} is not available. Manpage $@ cannot be updated" >&2
endif

=== scripts/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.13)
+cmake_minimum_required(VERSION 3.25)
 
 set(VU_SYSCALL_CONF ${PROJECT_SOURCE_DIR}/vu_syscalls.conf)
 set(VU_SCRIPT_PATH ${PROJECT_SOURCE_DIR}/scripts)

=== test_modules/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.13)
+cmake_minimum_required(VERSION 3.25)
 
 include_directories(${VU_HEADERS})
 set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)

=== umvu/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.13)
+cmake_minimum_required(VERSION 3.25)
 
 set(UMVU_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src)
 set(UMVU_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/include)

=== vubinfmt/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.13)
+cmake_minimum_required(VERSION 3.25)
 
 include_directories(${VU_HEADERS})

=== vudev/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.13)
+cmake_minimum_required(VERSION 3.25)
 
 include_directories(${VU_HEADERS})

=== vudev_modules/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.13)
+cmake_minimum_required(VERSION 3.25)
 
 include_directories(${VU_HEADERS} ${VU_DYN_HEADER_PATH})
 set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)

=== debian/changelog ===
vuos (0.9.4-1) unstable; urgency=medium

  * New upstream version 0.9.4

 -- Renzo Davoli <renzo@cs.unibo.it>  Tue, 28 Oct 2025 17:56:48 +0100

vuos (0.9.3-1) unstable; urgency=medium

  * New upstream version 0.9.3
  * Closes: #1113625

 -- Renzo Davoli <renzo@cs.unibo.it>  Wed, 15 Oct 2025 14:27:04 +0200

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
  libvolatilestream-dev,
  python3-minimal,
  strcase-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: http://www.virtualsquare.org/
 Vcs-Git: https://salsa.debian.org/virtualsquare-team/vuos.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

%:
	dh $@

=== debian/watch ===
version=4

https://github.com/virtualsquare/vuos/tags \
   (?:.*?/)?@ANY_VERSION@@ARCHIVE_EXT@
